class DcopAmarokFailed(Exception):
	def __init__(self,command,status,output):
		Exception.__init__(self)
		self.status = status
		self.command = command
		self.output = output
	def __str__(self):
		return "DCOP amaroK failure: command %s failed with status '%s' and output %s"%(self.command,self.status,self.output)

def dcop_amarok_commandsplus(object_name,method_name,*args):
	from commandsplus import getstatusoutputerror
# 	args = [ shell_escape(a) for a in args ]
	command = ["dcop","amarok",object_name,method_name]
	def turnintostring(aparm):
		if aparm is True: return "true"
		if aparm is False: return "false"
		if type(aparm) is tuple:
			return tuple([turnintostring(a) for a in aparm])
		if type(aparm) is list: # falta manipuleo de dicts y otros iterables
			return [turnintostring(a) for a in aparm]
		return aparm
	
	newargs = turnintostring(args)
	for arg in newargs: command.append(arg)
# 	 %s %s"%(shell_escape(object_name)," ".join(args))
# 	if not "COALESCE" in command:
# 		logger.debug("running command %s"%command)
# 	logging.getLogger("dcopamarok").debug("%s being called",command)
	status,output,error=getstatusoutputerror(command)
	if not (status.exited and status.return_value == 0):
		raise DcopAmarokFailed(command,status,output+error)
	result = output.strip()
# 	logging.getLogger("dcopamarok").debug("%s(%s) = %s",method_name,args,result)
	return result

	
import logging
from threading import Lock
dcop_amarok_kdebindings_ocache_lock = Lock()

def dcop_amarok_kdebindings(object_name,method_name,*args):
	global dcop_amarok_kdebindings_ocache_lock
	from pydcop import DCOPObject
	dcop_amarok_kdebindings_ocache_lock.acquire()
	try:
		if not hasattr(dcop_amarok_kdebindings,"ocache"):
			dcop_amarok_kdebindings.ocache = {}
		if not dcop_amarok_kdebindings.ocache.has_key(object_name):
			dcop_amarok_kdebindings.ocache[object_name] = DCOPObject("amarok",object_name)
		object = dcop_amarok_kdebindings.ocache[object_name]
	finally:
		dcop_amarok_kdebindings_ocache_lock.release()
	
	try:
# 		FIXME: dumb kludge to avoid some sort of problem with DCOP communication in Unicode
		def turnintoiso(aparm):
			if type(aparm) is str: # FIXME: remove this kludge.  problema: si no hago esto, los caracteres no llegan bien.  osea llega doblemente codificado como utf8.
				return aparm.decode("utf-8").encode("iso-8859-1")
			if type(aparm) is unicode:
				return aparm.encode("iso-8859-1")
			if type(aparm) is tuple:
				return tuple([turnintoiso(a) for a in aparm])
			if type(aparm) is list: # falta manipuleo de dicts y otros iterables
				return [turnintoiso(a) for a in aparm]
			return aparm
		
		newargs = turnintoiso(args)
		result = getattr(object,method_name)(*newargs)
# 		logging.getLogger("dcopamarok").debug("%s(%s) = %s",method_name,args,result)
		return result
	except RuntimeError,e:
		command = ["dcop","amarok",object_name,method_name]
		for a in args: command.append(a)
		raise DcopAmarokFailed(command,1,e.args[0])
			

try:
	raise ImportError,"disabled until UTF issue solved"
	from pydcop import DCOPObject
	dcop_amarok = dcop_amarok_kdebindings
except ImportError:
	from commandsplus import getstatusoutputerror
	dcop_amarok = dcop_amarok_commandsplus
	